//////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2010, 2023 Contributors to the Eclipse Foundation
//
// See the NOTICE file(s) distributed with this work for additional
// information regarding copyright ownership.
//
// This program and the accompanying materials are made available
// under the terms of the MIT License which is available at
// https://opensource.org/licenses/MIT
//
// SPDX-License-Identifier: MIT
//////////////////////////////////////////////////////////////////////////////

package org.eclipse.escet.cif.simulator.output.plotviz;

import java.awt.Color;

/** Material UI colors (level 600). */
@SuppressWarnings("javadoc")
public class MaterialUiColors600 {
    // See https://materialuicolors.co/
    public static final Color RED = new Color(229, 57, 53);

    public static final Color PINK = new Color(216, 27, 96);

    public static final Color PURPLE = new Color(142, 36, 170);

    public static final Color DEEP_PURPLE = new Color(94, 53, 177);

    public static final Color INDIGO = new Color(57, 73, 171);

    public static final Color BLUE = new Color(30, 136, 229);

    public static final Color LIGHT_BLUE = new Color(3, 155, 229);

    public static final Color CYAN = new Color(0, 172, 193);

    public static final Color TEAL = new Color(0, 137, 123);

    public static final Color GREEN = new Color(67, 160, 71);

    public static final Color LIGHT_GREEN = new Color(124, 179, 66);

    public static final Color LIME = new Color(192, 202, 51);

    public static final Color YELLOW = new Color(253, 216, 53);

    public static final Color AMBER = new Color(255, 179, 0);

    public static final Color ORANGE = new Color(251, 140, 0);

    public static final Color DEEP_ORANGE = new Color(244, 81, 30);

    public static final Color BROWN = new Color(109, 76, 65);

    public static final Color GREY = new Color(117, 117, 117);

    public static final Color BLUE_GREY = new Color(84, 110, 122);

    /** Material UI colors (level 600). */
    public static final Color[] COLORS = {RED, LIGHT_GREEN, BLUE, YELLOW, ORANGE, PURPLE, TEAL, CYAN, BROWN, INDIGO,
            GREEN, GREY};

    /** Constructor for the {@link MaterialUiColors600} class. */
    private MaterialUiColors600() {
        // Static class.
    }
}
